import os

import axipy
from axipy import Plugin, Position

from FillFieldGUID.ui.add_helper.observers import factoryObserver
from FillFieldGUID.ui.dlgFiilGUID import FillGuidField


class FillGuidPlugin(Plugin):
    def load(self) -> None:
        self.__title="Заполнение колонки GUID"
        self.__name_observer="GuidFill"
        self.__observer_ready=factoryObserver(self.__name_observer)
        self.__local_file_icon_tools = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons',
                                                    'fillcolumn_32x32.png')
        self.__action = self.create_action(
            self.__title,
            icon=self.__local_file_icon_tools,
            on_click=self.__run_fill, enable_on=self.__name_observer
        )
        position = Position('Таблица', 'Запрос')

        position.add(self.__action)

    def __run_fill(self):
        dlg_fill=FillGuidField(axipy.mainwindow.qt_object())
        dlg_fill.exec_()
    def unload(self) -> None:
        self.__action.remove()
