import uuid

import axipy
from PySide2.QtCore import QObject, Signal

from FillFieldGUID.ui.add_helper.tab_helper import CalcIntProcent, TableCache


class TabFillGuid(QObject):
    change_proc=Signal(int)
    def __init__(self,tab_name,field_name):
        super().__init__()
        self.__tab_name=tab_name
        self.__fild_name=field_name
        self.__isCancel=False
        self.__count_fill=0
    def run(self):
        tab=axipy.data_manager.find(self.__tab_name)
        count=tab.count()
        proc_cls=CalcIntProcent(count)
        table_update_cahe=TableCache(tab)
        for i,ft in enumerate(tab.items()):
            proc=proc_cls.getValue(i)
            if proc is not None:
                self.change_proc.emit(proc)
            if self.__isCancel:
                break
            self.__count_fill=self.__count_fill+1
            str_uuid=str(uuid.uuid4())
            ft[self.__fild_name]=str_uuid
            table_update_cahe.add(ft)
        #self.change_proc.emit(proc)
        table_update_cahe.end()
        return
    def setCancel(self):
        self.__isCancel=True
    @property
    def countProcessing(self):
        return self.__count_fill