import os

import axipy
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog
from axipy import Table

from FillFieldGUID.ui.add_helper.fillTableGuid import TabFillGuid
from FillFieldGUID.ui.add_helper.tab_helper import getStringFields


class FillGuidField(QDialog):
    def __init__(self,parent=None):
        super().__init__(parent)
        self.__parent=parent
        self.ui=self.load_ui("DlgFiilGuid.ui",parent)
        self.ui.cmb_tables.currentIndexChanged.connect(self.__change_tab)
        self.ui.pb_run.clicked.connect(self.__run)
        self.ui.pb_cancel.clicked.connect(self.__cancel)
        self.__att_info_tabs={}
        self.__initTabsList()
        self.__cls_fill=None

    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def __initTabsList(self):

        for tab in axipy.data_manager.tables:
            str_att=getStringFields(tab)
            if str_att is None:
                continue
            self.__att_info_tabs[tab.name]=str_att
            self.ui.cmb_tables.addItem(tab.name)
        self.ui.cmb_tables.setCurrentIndex(0)

    def __change_tab(self,index):
        curent_tab=self.ui.cmb_tables.currentText()
        att_names=self.__att_info_tabs[curent_tab]
        self.ui.cmb_att_name.clear()

        self.ui.cmb_att_name.addItems(att_names)
        self.ui.cmb_att_name.setCurrentIndex(0)
    def __run(self):
        name_table=self.ui.cmb_tables.currentText()
        name_field=self.ui.cmb_att_name.currentText()
        self.ui.pb_run.setEnabled(False)
        self.ui.pb_cancel.setText("Прервать")
        self.__cls_fill=TabFillGuid(name_table,name_field)
        self.__cls_fill.change_proc.connect(self.__change_progres)

        def task_run(t: axipy.Task):
            self.__cls_fill.run()

        task = axipy.Task(task_run)
        task.finished.connect(self.__end_task)
        task.start()
    def __cancel(self):
        if self.__cls_fill is not None:
            self.__cls_fill.setCancel()
        else:
            self.ui.close()
    def exec_(self):
        self.ui.exec_()
    def close(self):
        self.ui.close()
    def __change_progres(self,value):
        self.ui.progressBar.setValue(value)

    def __end_task(self):
        axipy.Notifications.push("Заполнение GUID","Заполнено "+str(self.__cls_fill.countProcessing),axipy.Notifications.Warning)
        self.ui.pb_run.setEnabled(True)
        self.ui.pb_cancel.setText("Закрыть")
        self.__cls_fill.change_proc.disconnect(self.__change_progres)
        self.ui.progressBar.setValue(100)
        self.__cls_fill=None
        self.ui.close()
    def finished(self):
        if self.__cls_fill is not None:
            self.__cls_fill.setCancel()
        else:
            self.ui.close()

